// @check-accepted: *

#include <iostream>
#include <queue>
#include <vector>
#include <fstream>


int main() {
	
	std::ifstream fin("patrol3.in");
	std::ofstream fout("patrol3.out");
    int n, m, l;
    fin >> n >> m >> l;

    std::vector<std::vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        fin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    std::vector<int> c(l);
    for (auto &x : c) fin >> x;

    std::vector<int> dist(n, 1e8);
    std::priority_queue<std::pair<int, int>, std::vector<std::pair<int, int>>, std::greater<>> q;
    dist[0] = 0;
    q.push({0, 0});
    
    while (!q.empty()) {
        int d = q.top().first;
        int v = q.top().second;
        q.pop();
        if (dist[v] != d) continue;

        for (int u : g[v]) {
            int t = dist[v] + 1;
            if (dist[u] <= t) continue;
            if (c[t % c.size()] != u) {
                dist[u] = t;
                q.push({dist[u], u});
            } else if (t + 1 < dist[u]) {
                dist[u] = t + 1;
                q.push({dist[u], u});
            }
        }
    }

    fout << (dist[n - 1] == 1e8 ? -1 : dist[n - 1]) << '\n';
}
